var TimerController = JSB.defineClass('TimerController : UIViewController', {
  viewDidLoad: function() {
    self.navigationItem.title = 'Web';
	self.istop = false;
    self.lastOffset = 0;
	var savedposition = NSUserDefaults.standardUserDefaults().objectForKey('my_marginnote_timer_position');
    if(savedposition)self.istop = savedposition;
    var webFrame = self.view.bounds;

    self.webView = new UIWebView(webFrame);
    
    self.webView.backgroundColor = UIColor.whiteColor();
    self.webView.scalesPageToFit = false;
    self.webView.autoresizingMask = (1 << 1 | 1 << 4);
    self.webView.delegate = self;
    self.webView.scrollView.delegate = self;
    self.webView.layer.cornerRadius = 15;
    self.webView.layer.masksToBounds = false;
    self.view.layer.shadowOffset = {width:0,height:0};
    self.view.layer.shadowRadius = 10;
    self.view.layer.shadowOpacity = 1;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5,1);
    self.view.addSubview(self.webView);
    
    self.webView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString('https://vclock.com/timer/')));

    self.lanButton = UIButton.buttonWithType(0);
    self.lanButton.frame = {x:webFrame.x,y:webFrame.y,width:0,height:0};
    self.lanButton.autoresizingMask = (1 << 3);
    self.lanButton.setTitleForState('Language',0);
    self.lanButton.setTitleColorForState(Application.sharedInstance().defaultTintColorForDarkBackground,0);
    var highlightColor = UIColor.blendedColor(Application.sharedInstance().defaultTintColorForDarkBackground,Application.sharedInstance().defaultTextColor,0.8);
    self.lanButton.setTitleColorForState(highlightColor,1);
    self.lanButton.backgroundColor = Application.sharedInstance().defaultTextColor.colorWithAlphaComponent(0.6);
    self.lanButton.layer.cornerRadius = 10;
    self.lanButton.layer.masksToBounds = true;
    self.lanButton.titleLabel.font = UIFont.systemFontOfSize(14);
    self.lanButton.addTargetActionForControlEvents(self,'changeLanguage:',1<<6);
    self.view.addSubview(self.lanButton);
	self.moveButton = UIButton.buttonWithType(0);
    self.moveButton.frame = {x:webFrame.x,y:webFrame.y + (webFrame.height - 40)*95/260,width:webFrame.width,height:40};
    self.moveButton.autoresizingMask = (1 << 3);
	if(self.istop){
    self.moveButton.setTitleForState('+',0);}
	else{
		self.moveButton.setTitleForState('-',0);}
    self.moveButton.setTitleColorForState(Application.sharedInstance().defaultTintColorForDarkBackground,0);
    self.moveButton.setTitleColorForState(highlightColor,1);
    self.moveButton.backgroundColor = Application.sharedInstance().defaultTextColor.colorWithAlphaComponent(0.6);
    self.moveButton.layer.cornerRadius = 10;
    self.moveButton.layer.masksToBounds = true;
    self.moveButton.titleLabel.font = UIFont.systemFontOfSize(14);
    self.moveButton.addTargetActionForControlEvents(self,'changeposition:',1<<6);
    self.view.addSubview(self.moveButton);
  },
  viewWillAppear: function(animated) {
    self.webView.delegate = self;
    self.timer = NSTimer.scheduledTimerWithTimeInterval(1/10,true,function(timer){
    self.updateOffset();
    });

  },
  viewWillDisappear: function(animated) {
    self.webView.stopLoading();
    self.webView.delegate = null;
    //if(self.timer)self.timer.invalidate();

    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
  viewWillLayoutSubviews: function() {
    self.updateOffset();
  },
  scrollViewDidScroll: function() {
    if(self.webView.scrollView.contentOffset.y != self.lastOffset){
      self.lastOffset = self.webView.scrollView.contentOffset.y;
	  self.webView.evaluateJavaScript('document.getElementsByClassName("dl_header")[0].style.display = "none";\
    document.getElementsByClassName("lmt__stickyMenubar_background")[0].style.display = "none";\
    document.getElementsByClassName("lmt__language_container")[0].style.display = "none";\
    document.getElementsByClassName("lmt__language_container")[1].style.display = "none";\
    ',function(ret){});
    }
    else return;
    //if(self.timer){
    //  self.timer.invalidate();
    //}
    //self.timer = NSTimer.scheduledTimerWithTimeInterval(3,true,function(timer){
    //  self.updateOffset();
    //});

  },
  webViewDidStartLoad: function(webView) {
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    Application.sharedInstance().waitHUDOnView("",self.view);
  },
  webViewDidFinishLoad: function(webView) {
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    self.updateOffset();
    Application.sharedInstance().stopWaitHUDOnView(self.view);

  },
  webViewDidFailLoadWithError: function(webView, error) {
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    Application.sharedInstance().stopWaitHUDOnView(self.view);
  var lan = NSLocale.preferredLanguages().length?NSLocale.preferredLanguages()[0].substring(0,2):'en';

    //var errorString = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\"><html><head><meta http-equiv='Content-Type' content='text/html;charset=utf-8'><title></title></head><body><div style='width: 100%%; text-align: center; font-size: 36pt; color: red;'>An error occurred:<br>%@</div></body></html>";
    //errorString = errorString.replace("%@", error.localizedDescription);
    
    //self.webView.loadHTMLStringBaseURL(errorString, null);
     if(lan == 'zh')
      Application.sharedInstance().showHUD('网页加载失败，请稍后重试',self.view.window,2);
    else
      Application.sharedInstance().showHUD('The page failed to load, please try again later',self.view.window,2);
  },

  changeposition: function(sender) {
	self.istop=!self.istop;
	self.updateposition();
  },
  });
  
TimerController.prototype.updateposition = function(){
    if(this.istop){
		this.moveButton.setTitleForState('+',0);
		NSUserDefaults.standardUserDefaults().setObjectForKey(true,'my_marginnote_timer_position');
		this.istop=true;
		var frame = Application.sharedInstance().studyController(this.view.window).view.bounds;
		this.view.frame = {x:frame.width*357/512 - 120,y:frame.y,width:350,height:300};
	}
	else{
		this.moveButton.setTitleForState('-',0);
		NSUserDefaults.standardUserDefaults().setObjectForKey(false,'my_marginnote_timer_position');
		this.istop=false;
		var frame = Application.sharedInstance().studyController(this.view.window).view.bounds;
		this.view.frame = {x:frame.width - 40,y:frame.height*74/1000,width:40,height:40};
	};
	var webFrame = self.view.bounds;
	this.moveButton.frame = {x:webFrame.x,y:webFrame.y,width:350,height:40};
	this.lanButton.frame = {x:webFrame.x,y:frame.y,width:0,height:0};
  };

TimerController.prototype.updateOffset = function(){
  if(!this.webView||!this.webView.window)return;
  var webControlerler = this;
  this.webView.evaluateJavaScript('document.getElementsByClassName("lmt__side_container--target")[0].getBoundingClientRect().top + document.body.scrollTop+document.documentElement.scrollTop;',function(ret){
    if(!webControlerler.webView)return;
    if(ret && !isNaN(parseFloat(ret))){
      webControlerler.webView.scrollView.contentOffset = {x:0,y:parseFloat(ret)+0};          
    }
    else{
      webControlerler.webView.scrollView.contentOffset = {x:0,y:0};          
    }
  });
  this.webView.evaluateJavaScript('document.getElementsByClassName("dl_header")[0].style.display = "none";\
    document.getElementsByClassName("lmt__stickyMenubar_background")[0].style.display = "none";\
    document.getElementsByClassName("lmt__language_container")[0].style.display = "none";\
    document.getElementsByClassName("lmt__language_container")[1].style.display = "none";\
    document.querySelector("#dl_translator > div.lmt__docTrans-tab-container").style.display = "none";\
    document.querySelector("#lmt_quotes_article > div.dl_top_element.dl_top_element--wide > div.lmt_quotes").style.display = "none";\
  document.querySelector("#lmt_pro_ad_container_1").style.display = "none";\
  document.querySelector("#lmt_quotes_article").style.display = "none";\
  document.querySelector("body > footer").style.display = "none";\
  document.querySelector("#dl_cookieBanner > div > div > div").style.display = "none";\
    ',function(ret){});
}
