JSB.newAddon = function(mainPath){
  JSB.require('TimerController');
  var newAddonClass = JSB.defineClass('timerAddon : JSExtension', /*Instance members*/{
    //Window initialize
    sceneWillConnect: function() {
        self.webController = TimerController.new();
    },
    //Window disconnect
    sceneDidDisconnect: function() {
    },
    //Window resign active
    sceneWillResignActive: function() {
    },
    //Window become active
    sceneDidBecomeActive: function() {
    },
    notebookWillOpen: function(notebookid) {
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnNote:','PopupMenuOnNote');
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnSelection:','PopupMenuOnSelection');
      NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){
        var deepl_on = NSUserDefaults.standardUserDefaults().objectForKey('my_marginnote_timer_on');
		
        if(Application.sharedInstance().studyController(self.window).studyMode < 3 && deepl_on == true){// Not support in card deck mode
          Application.sharedInstance().studyController(self.window).view.addSubview(self.webController.view);
          self.layoutWebController();
          Application.sharedInstance().studyController(self.window).refreshAddonCommands();
          NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){ 
            Application.sharedInstance().studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      });
    },
    notebookWillClose: function(notebookid) {
      self.webController.view.removeFromSuperview();  
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnNote');
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnSelection');
    },
    documentDidOpen: function(docmd5) {
    },
    documentWillClose: function(docmd5) {
    },
    controllerWillLayoutSubviews: function(controller) {
      if(controller == Application.sharedInstance().studyController(self.window)){
          self.layoutWebController();
      }
    },
    queryAddonCommandStatus: function() {
      if(Application.sharedInstance().studyController(self.window).studyMode < 3)
        return {image:'timer.PNG',object:self,selector:'toggleTranslate:',checked:(self.webController.view.window?true:false)};
      return null;
    },
    //Clicking note
    onPopupMenuOnNote: function(sender){
      if(!Application.sharedInstance().checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.webController.view.window)return;
      var text = sender.userInfo.note.allNoteText();
      if(text && text.length){
        self.webController.translateText(text);
      }
    },
    //Selecting text on pdf or epub
    onPopupMenuOnSelection: function(sender){
      if(!Application.sharedInstance().checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.webController.view.window)return;
      var text = sender.userInfo.documentController.selectionText;
      if(text && text.length){
        self.webController.translateText(text);
      }
    },
    toggleTranslate: function(sender) {
      if(self.webController.view.window){
        self.webController.view.removeFromSuperview();
        NSUserDefaults.standardUserDefaults().setObjectForKey(false,'my_marginnote_timer_on');
      }
      else{
        Application.sharedInstance().studyController(self.window).view.addSubview(self.webController.view);
        self.layoutWebController();
        NSUserDefaults.standardUserDefaults().setObjectForKey(true,'my_marginnote_timer_on');
        NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){ 
          Application.sharedInstance().studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      }
      Application.sharedInstance().studyController(self.window).refreshAddonCommands();
    },
  }, /*Class members*/{
    addonDidConnect: function() {
    },
    addonWillDisconnect: function() {
    },
    applicationWillEnterForeground: function() {
    },
    applicationDidEnterBackground: function() {
    },
    applicationDidReceiveLocalNotification: function(notify) {
    },
  });
  newAddonClass.prototype.layoutWebController = function(){
	if(this.webController.istop){
		this.webController.moveButton.setTitleForState('+',0);
		NSUserDefaults.standardUserDefaults().setObjectForKey(true,'my_marginnote_timer_position');
		this.webController.istop=true;
		var frame = Application.sharedInstance().studyController(this.window).view.bounds;
		this.webController.view.frame = {x:frame.width*357/512 - 120,y:frame.y,width:350,height:300};
	}
	else{
		this.webController.moveButton.setTitleForState('-',0);
		NSUserDefaults.standardUserDefaults().setObjectForKey(false,'my_marginnote_timer_position');
		this.webController.istop=false;
		var frame = Application.sharedInstance().studyController(this.window).view.bounds;
		this.webController.view.frame = {x:frame.width - 40,y:frame.height*74/1000,width:350,height:40};
	}
	var webFrame = this.webController.view.bounds;
	this.webController.moveButton.frame = {x:webFrame.x,y:webFrame.y,width:webFrame.width,height:40};
	this.webController.lanButton.frame = {x:webFrame.x,y:webFrame.y,width:0,height:0}
  };
  return newAddonClass;
};

